# Class MidiDeviceProvider

java.lang.Object
javax.sound.midi.spi.MidiDeviceProvider

public abstract class MidiDeviceProvider extends Object
A `MidiDeviceProvider` is a factory or provider for a particular type of MIDI device. This mechanism allows the implementation to determine how resources are managed in the creation and management of a device.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`MidiDeviceProvider()`
Constructor for subclasses to call.

## Method Summary

Modifier and Type
Method
Description
`abstract MidiDevice`
`getDevice(MidiDevice.Info info)`
Obtains an instance of the device represented by the info object.
`abstract MidiDevice.Info[]`
`getDeviceInfo()`
Obtains the set of info objects representing the device or devices provided by this `MidiDeviceProvider`.
`boolean`
`isDeviceSupported(MidiDevice.Info info)`
Indicates whether the device provider supports the device represented by the specified device info object.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### MidiDeviceProvider

protected MidiDeviceProvider()
Constructor for subclasses to call.

## Method Details

### isDeviceSupported

public boolean isDeviceSupported(MidiDevice.Info info)
Indicates whether the device provider supports the device represented by the specified device info object.

Parameters:
  `info` - an info object that describes the device for which support is queried
Returns:
  `true` if the specified device is supported, otherwise `false`
Throws:
  `NullPointerException` - if `info` is `null`

### getDeviceInfo

public abstract MidiDevice.Info[] getDeviceInfo()
Obtains the set of info objects representing the device or devices provided by this `MidiDeviceProvider`.

Returns:
  set of device info objects

### getDevice

public abstract MidiDevice getDevice(MidiDevice.Info info)
Obtains an instance of the device represented by the info object.

Parameters:
  `info` - an info object that describes the desired device
Returns:
  device instance
Throws:
  `IllegalArgumentException` - if the info object specified does not match the info object for a device supported by this `MidiDeviceProvider`
  `NullPointerException` - if `info` is `null`